{*****************************************************************************}
{                                                                             }
{       MultiMonitorParam                                                     }
{                                                                             }
{       Copyright (c) 2007 Moon Doldo                                         }
{                                                                             }
{̓eDelphi-ML                                                          }
{[Delphi:90115] EChEő剻܂܍ő剻TCY𒲐߂              }
{ŕtXQlɂĂ܂B                                             }
{                                                                             }
{*****************************************************************************}

unit MultiMonitorParam;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Math, MultiMon, UxTheme;

type
  // TargetFormw肳ĂȂ݂ȂG[
  ETargetFormIsNotFound = class(Exception);

  // MonitorInfoێNX
  TMonitorInfoParam = class(TComponent)
  private
    FMonitorInfo : TMonitorInfo;
    FDisplayMonitorInfo: TMonitorInfo;
    FTargetForm: TForm;

    procedure SetTargetForm(const Value: TForm);
  protected
    // MonitorInfo̎擾
    procedure GetMonitorInfoParam;

  public
    //TComponent OwnertRXgN^`
    constructor Create(AOwner: TComponent); override;

    // fBXvCj^Ɋւ擾
    // vC}j^̍_(0,0)ƂčWlԂ
    function MonitorInfo: TMonitorInfo;
    // fBXvCj^Ɋւ擾
    // ej^̍_(0,0)ƂčWlԂ
    function DisplayMonitorInfo: TMonitorInfo;

    // j^̐擾
    function MonitorCount: Integer;

    // j^ԍ̎擾
    function MonitorNum: Integer;
  published
    // Ώۂ̃EChEݒ
    property TargetForm: TForm read FTargetForm write SetTargetForm;
  end;

  // ő剻̊ǗNX
  TMultiMonitorMaxInfoCalc = class(TMonitorInfoParam)
  private
    FMaxSizeY: Integer;
    FMaxSizeX: Integer;
    FMaxPositionY: Integer;
    FMaxPositionX: Integer;
    FMaxAlign: TAlign;

    procedure SetMaxSizeX(const Value: Integer);
    procedure SetMaxSizeY(const Value: Integer);
    procedure SetMaxPositionX(const Value: Integer);
    procedure SetMaxPositionY(const Value: Integer);

    procedure SetMaxAlign(const Value: TAlign);
  protected
    // tH[̑傫ƈʒu̐(WMGetMinMaxInfo)
    procedure WMNoneGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
    procedure WMClientGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
    procedure WMCustomGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
    procedure WMTopGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
    procedure WMBottomGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
    procedure WMLeftGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
    procedure WMRightGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
  public
    //TComponent OwnertRXgN^`
    constructor Create(AOwner: TComponent); override;
    //fXgN^`
    destructor Destroy; override;

    // tH[̑傫ƈʒu̐
    procedure WMGetMinMaxInfo(var msg : TWMGetMinMaxInfo);

    // tH[̑傫ƈʒu̐(ɍő剻Ăꍇ)
    procedure WMGetMinMaxInfo2;

    // ʏ̏Ԃ̃tH[K؂Ȉʒuֈړ
    procedure SetFormSafePosition;
  published
    // ݒ肵EChETCYw肷
    // alLeft, alRight, alCustom̏ꍇ̂ݎs
    property MaxSizeX: Integer read FMaxSizeX write SetMaxSizeX;
    // alTop, alBottom, alCustom̏ꍇ̂ݎs
    property MaxSizeY: Integer read FMaxSizeY write SetMaxSizeY;

    // ݒ肵ʒuw肷(e탂j^̗Lʂ̍_(0,0))
    // alCustom̏ꍇ̂ݎs
    property MaxPositionX: Integer read FMaxPositionX write SetMaxPositionX;
    property MaxPositionY: Integer read FMaxPositionY write SetMaxPositionY;

    // ő剻̍ۂɁAj^ŃRg[𑵂@w肵܂B
    property MaxAlign: TAlign read FMaxAlign write SetMaxAlign;
  end;

// EChEnh烂j^ԍ̎擾
function GetHWNDToMonitorNum(hWnd: HWND): Integer;

// Windows XP/Server2003
// ȂuWindows XP X^Cvݒ肳Ă邩`FbN
function isWindowsXPUseThemes: Boolean;

implementation

function GetHWNDToMonitorNum(hWnd: HWND): Integer;
var
  wHMonitor: HMonitor;
  wHMonitorIndex: Integer;
  wMonitor: TMonitor;
begin
  Result := -1;
  wHMonitor := MonitorFromWindow(hWnd, MONITOR_DEFAULTTONEAREST);
  for wHMonitorIndex := 0 to Screen.MonitorCount - 1 do
  begin
    if Screen.Monitors[wHMonitorIndex].Handle = wHMonitor then
    begin
      wMonitor := Screen.Monitors[wHMonitorIndex];
      result := wMonitor.MonitorNum;
      Exit;
    end;
  end;
end;

function isWindowsXPUseThemes: Boolean;
var
  WkMajor, WkMinor: LongInt;
  WkInfo: TOSVersionInfo;
begin
  WkInfo.dwOSVersionInfoSize := SizeOf(WkInfo);
  GetVersionEx(WkInfo);
  WkMajor := WkInfo.dwMajorVersion ;
  WkMinor := WkInfo.dwMinorVersion ;
  // dwMajorVersion52000EXPEServer2003
  if WkMajor = 5 then
  begin
    // dwMinorVersion1XP
    // dwMinorVersion2Server2003
    if (WkMinor = 1) or (WkMinor = 2) then
    begin
      // UxThemeUseThemes
      // OSe[}ΉNVbN[h𔻕ʂ
      // AvP[V͊֌WȂ
      result := UseThemes;
    end
    else begin
      result := False;
    end;
  end
  else begin
    result := False;
  end;
end;

{ TMultiMonitorMaxInfoCalc }

constructor TMultiMonitorMaxInfoCalc.Create(AOwner: TComponent);
begin
  inherited;  //ʂ̃NGCgĂяoiCreate\Lȗj
  //Createďoɕʂ̏̂ʓI

  FMaxAlign := alCustom;

  FMaxSizeY := 0;
  FMaxSizeX := 0;
  FMaxPositionY := 0;
  FMaxPositionX := 0;
end;

destructor TMultiMonitorMaxInfoCalc.Destroy;
begin
  inherited;
end;

procedure TMultiMonitorMaxInfoCalc.SetFormSafePosition;
var
  WkMonitorInfo : TMonitorInfo;

  WkMonitorInfoWidth, WkMonitorInfoHeight: Integer;
  WkTargetFormRight, WkTargetFormBottom: Integer;

  WkLeft, WkTop: Integer;
begin
  // EChE݂Ȃꍇ͗O𔭐
  if FTargetForm = nil then
  begin
    raise ETargetFormIsNotFound.Create('TargetFormw肳Ă܂');
  end;
  if IsWindow(FTargetForm.Handle) = False then
  begin
    raise ETargetFormIsNotFound.Create('TargetFormŎw肵tH[݂Ă܂');
  end;

  if FTargetForm.WindowState = wsNormal then
  begin
    // fBXvCj^Ɋւ擾
    WkMonitorInfo := Self.MonitorInfo;

    WkLeft := FTargetForm.Left;
    WkTop := FTargetForm.Top;

    // オLʂ͂ݏoĂ璼
    if WkLeft < WkMonitorInfo.rcWork.Left then
    begin
      WkLeft := WkMonitorInfo.rcWork.Left;
    end;
    if WkTop < WkMonitorInfo.rcWork.Top then
    begin
      WkTop := WkMonitorInfo.rcWork.Top;
    end;

    // ELʂ͂ݏoĂ璼
    // ALʂ̂tH[ꍇ̂ݍsiDɂ邽߁j
    WkMonitorInfoWidth :=
      WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left;
    if FTargetForm.Width <= WkMonitorInfoWidth then
    begin
      WkTargetFormRight := WkLeft + FTargetForm.Width;
      if WkTargetFormRight > WkMonitorInfo.rcWork.Right then
      begin
        WkLeft := WkMonitorInfo.rcWork.Right - FTargetForm.Width;
      end;
    end;
    WkMonitorInfoHeight :=
      WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top;
    if FTargetForm.Height <= WkMonitorInfoHeight then
    begin
      WkTargetFormBottom := WkTop + FTargetForm.Height;
      if WkTargetFormBottom > WkMonitorInfo.rcWork.Bottom then
      begin
        WkTop := WkMonitorInfo.rcWork.Bottom - FTargetForm.Height;
      end;
    end;

    FTargetForm.Left := WkLeft;
    FTargetForm.Top := WkTop;
  end;
end;

procedure TMultiMonitorMaxInfoCalc.SetMaxAlign(const Value: TAlign);
begin
  FMaxAlign := Value;
  WMGetMinMaxInfo2;
end;

procedure TMultiMonitorMaxInfoCalc.SetMaxPositionX(const Value: Integer);
begin
  FMaxPositionX := Value;
end;

procedure TMultiMonitorMaxInfoCalc.SetMaxPositionY(const Value: Integer);
begin
  FMaxPositionY := Value;
end;

procedure TMultiMonitorMaxInfoCalc.SetMaxSizeX(const Value: Integer);
begin
  FMaxSizeX := Value;
end;

procedure TMultiMonitorMaxInfoCalc.SetMaxSizeY(const Value: Integer);
begin
  FMaxSizeY := Value;
end;

procedure TMultiMonitorMaxInfoCalc.WMBottomGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  msg.MinMaxInfo.ptMaxSize.X :=
    WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left;
  msg.MinMaxInfo.ptMaxSize.Y :=
    Min(FMaxSizeY,
    WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top);

  // tH[̈ʒuێ
  WkPositionX := WkMonitorInfo.rcWork.Left;
  WkPositionY := WkMonitorInfo.rcWork.Bottom - msg.MinMaxInfo.ptMaxSize.Y;

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top;
  end;

  // WindowsXPEServer2003OSe[}Ή̏ꍇ
  // BorderStylebsDialogݒ肳
  // E\Ȃ̂ŁA̒̂߂ɋE̕
  if (isWindowsXPUseThemes = True) and
    (TargetForm.BorderStyle = bsDialog) then
  begin
    // ̌ʕt̃EBhE̋E̕ +
    // ̌ʂ̂ȂEBhE̋E̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
    WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CXBORDER);

    msg.MinMaxInfo.ptMaxSize.X :=
      msg.MinMaxInfo.ptMaxSize.X + (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      msg.MinMaxInfo.ptMaxSize.Y + (WkBoundaryY * 2);
    msg.MinMaxInfo.ptMaxPosition.X :=
      msg.MinMaxInfo.ptMaxPosition.X - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      msg.MinMaxInfo.ptMaxPosition.Y - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

procedure TMultiMonitorMaxInfoCalc.WMCustomGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̈ʒuێ
  WkPositionX :=
    FMaxPositionX + WkMonitorInfo.rcWork.Left;
  WkPositionY :=
    FMaxPositionY + WkMonitorInfo.rcWork.Top;

  // Lʂ獶ɂ͂ݏoĂꍇ͒
  if WkPositionX < WkMonitorInfo.rcWork.Left then
  begin
    WkPositionX := WkMonitorInfo.rcWork.Left;
  end;
  if WkPositionY < WkMonitorInfo.rcWork.Top then
  begin
    WkPositionY := WkMonitorInfo.rcWork.Top;
  end;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  // Lʈȏ̑傫ɂȂȂ悤ɑ傫C
  msg.MinMaxInfo.ptMaxSize.X :=
    Min(FMaxSizeX,
    WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left - FMaxPositionX);
  msg.MinMaxInfo.ptMaxSize.Y :=
    Min(FMaxSizeY,
    WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top - FMaxPositionY);

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top;
  end;

  // WindowsXPEServer2003OSe[}Ή̏ꍇ
  // BorderStylebsDialogݒ肳
  // E\Ȃ̂ŁA̒̂߂ɋE̕
  if (isWindowsXPUseThemes = True) and
    (TargetForm.BorderStyle = bsDialog) then
  begin
    // ̌ʕt̃EBhE̋E̕ +
    // ̌ʂ̂ȂEBhE̋E̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
    WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CXBORDER);

    msg.MinMaxInfo.ptMaxSize.X :=
      msg.MinMaxInfo.ptMaxSize.X + (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      msg.MinMaxInfo.ptMaxSize.Y + (WkBoundaryY * 2);
    msg.MinMaxInfo.ptMaxPosition.X :=
      msg.MinMaxInfo.ptMaxPosition.X - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      msg.MinMaxInfo.ptMaxPosition.Y - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

procedure TMultiMonitorMaxInfoCalc.WMGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
begin
  // EChE݂Ȃꍇ͏I
  if FTargetForm = nil then
  begin
    Exit;
  end;
  if IsWindow(FTargetForm.Handle) = False then
  begin
    Exit;
  end;

  case FMaxAlign of
    alNone:
    begin
      WMNoneGetMinMaxInfo(msg);
    end;
    alClient:
    begin
      WMClientGetMinMaxInfo(msg);
    end;
    alCustom:
    begin
      WMCustomGetMinMaxInfo(msg);
    end;
    alTop:
    begin
      WMTopGetMinMaxInfo(msg);
    end;
    alBottom:
    begin
      WMBottomGetMinMaxInfo(msg);
    end;
    alLeft:
    begin
      WMLeftGetMinMaxInfo(msg);
    end;
    alRight:
    begin
      WMRightGetMinMaxInfo(msg);
    end;
  else
    raise Exception.Create('MaxAligñG[ł' + #13#10 +
      'vO~OG[łAJ҂ɂ₢킹');
  end;
end;


procedure TMultiMonitorMaxInfoCalc.WMGetMinMaxInfo2;
begin
  // EChE݂Ȃꍇ͏I
  if FTargetForm = nil then
  begin
    Exit;
  end;
  if IsWindow(FTargetForm.Handle) = False then
  begin
    Exit;
  end;

  // ő剻̎̂ݎs
  if IsZoomed(FTargetForm.Handle) then
  begin
    // ŏčő剻
    ShowWindow(FTargetForm.Handle, SW_NORMAL);
    ShowWindow(FTargetForm.Handle, SW_MAXIMIZE);

    // ȑÓA}ύX悤ɍĂ܂A
    // FXȏ(OSEtH[BorderStyleEOSe[}Ήj
    // œ삪sȂ̂ŒfOc
    // Delphi-MLŋĂ\󂠂܂B
  end;
end;

procedure TMultiMonitorMaxInfoCalc.WMLeftGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̈ʒuێ
  WkPositionX := WkMonitorInfo.rcWork.Left;
  WkPositionY := WkMonitorInfo.rcWork.Top;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  msg.MinMaxInfo.ptMaxSize.X :=
    Min(FMaxSizeX,
    WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left);
  msg.MinMaxInfo.ptMaxSize.Y :=
    WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top;

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top;
  end;

  // WindowsXPEServer2003OSe[}Ή̏ꍇ
  // BorderStylebsDialogݒ肳
  // E\Ȃ̂ŁA̒̂߂ɋE̕
  if (isWindowsXPUseThemes = True) and
    (TargetForm.BorderStyle = bsDialog) then
  begin
    // ̌ʕt̃EBhE̋E̕ +
    // ̌ʂ̂ȂEBhE̋E̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
    WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CXBORDER);

    msg.MinMaxInfo.ptMaxSize.X :=
      msg.MinMaxInfo.ptMaxSize.X + (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      msg.MinMaxInfo.ptMaxSize.Y + (WkBoundaryY * 2);
    msg.MinMaxInfo.ptMaxPosition.X :=
      msg.MinMaxInfo.ptMaxPosition.X - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      msg.MinMaxInfo.ptMaxPosition.Y - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

procedure TMultiMonitorMaxInfoCalc.WMClientGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̈ʒuێ
  WkPositionX := WkMonitorInfo.rcWork.Left;
  WkPositionY := WkMonitorInfo.rcWork.Top;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  msg.MinMaxInfo.ptMaxSize.X :=
    WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left;
  msg.MinMaxInfo.ptMaxSize.Y :=
    WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top;

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top;
  end;

  // WindowsXPEServer2003OSe[}Ή̏ꍇ
  // BorderStylebsDialogݒ肳
  // E\Ȃ̂ŁA̒̂߂ɋE̕
  if (isWindowsXPUseThemes = True) and
    (TargetForm.BorderStyle = bsDialog) then
  begin
    // ̌ʕt̃EBhE̋E̕ +
    // ̌ʂ̂ȂEBhE̋E̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
    WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CXBORDER);

    msg.MinMaxInfo.ptMaxSize.X :=
      msg.MinMaxInfo.ptMaxSize.X + (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      msg.MinMaxInfo.ptMaxSize.Y + (WkBoundaryY * 2);
    msg.MinMaxInfo.ptMaxPosition.X :=
      msg.MinMaxInfo.ptMaxPosition.X - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      msg.MinMaxInfo.ptMaxPosition.Y - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

procedure TMultiMonitorMaxInfoCalc.WMRightGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  msg.MinMaxInfo.ptMaxSize.X :=
    Min(FMaxSizeX,
    WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left);
  msg.MinMaxInfo.ptMaxSize.Y :=
    WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top;

  // tH[̈ʒuێ
  WkPositionX := WkMonitorInfo.rcWork.Right - msg.MinMaxInfo.ptMaxSize.X;
  WkPositionY := WkMonitorInfo.rcWork.Top;

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top;
  end;

  // WindowsXPEServer2003OSe[}Ή̏ꍇ
  // BorderStylebsDialogݒ肳
  // E\Ȃ̂ŁA̒̂߂ɋE̕
  if (isWindowsXPUseThemes = True) and
    (TargetForm.BorderStyle = bsDialog) then
  begin
    // ̌ʕt̃EBhE̋E̕ +
    // ̌ʂ̂ȂEBhE̋E̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
    WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CXBORDER);

    msg.MinMaxInfo.ptMaxSize.X :=
      msg.MinMaxInfo.ptMaxSize.X + (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      msg.MinMaxInfo.ptMaxSize.Y + (WkBoundaryY * 2);
    msg.MinMaxInfo.ptMaxPosition.X :=
      msg.MinMaxInfo.ptMaxPosition.X - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      msg.MinMaxInfo.ptMaxPosition.Y - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

procedure TMultiMonitorMaxInfoCalc.WMTopGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̈ʒuێ
  WkPositionX := WkMonitorInfo.rcWork.Left;
  WkPositionY := WkMonitorInfo.rcWork.Top;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  msg.MinMaxInfo.ptMaxSize.X :=
    WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left;
  msg.MinMaxInfo.ptMaxSize.Y :=
    Min(FMaxSizeY,
    WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top);

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top;
  end;

  // WindowsXPEServer2003OSe[}Ή̏ꍇ
  // BorderStylebsDialogݒ肳
  // E\Ȃ̂ŁA̒̂߂ɋE̕
  if (isWindowsXPUseThemes = True) and
    (TargetForm.BorderStyle = bsDialog) then
  begin
    // ̌ʕt̃EBhE̋E̕ +
    // ̌ʂ̂ȂEBhE̋E̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
    WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CXBORDER);

    msg.MinMaxInfo.ptMaxSize.X :=
      msg.MinMaxInfo.ptMaxSize.X + (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      msg.MinMaxInfo.ptMaxSize.Y + (WkBoundaryY * 2);
    msg.MinMaxInfo.ptMaxPosition.X :=
      msg.MinMaxInfo.ptMaxPosition.X - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      msg.MinMaxInfo.ptMaxPosition.Y - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

procedure TMultiMonitorMaxInfoCalc.WMNoneGetMinMaxInfo(
  var msg: TWMGetMinMaxInfo);
var
  WkMonitorInfo : TMonitorInfo;

  WkPositionX, WkPositionY: Integer;
  WkBoundaryX, WkBoundaryY: Integer;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_(0,0)ƂlAĂ
  WkMonitorInfo := Self.MonitorInfo;

  // tH[̈ʒuێ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    // bsSizeable, bsSingle 
    // ő剻̓j^Lʂ͈̔͂ōL
    WkPositionX := WkMonitorInfo.rcWork.Left;
    WkPositionY := WkMonitorInfo.rcWork.Top;
  end
  else begin
    // bsDialog, bsNone, bsSizeToolWin, bsToolWindow 
    // ő剻̓j^Ŝ͈̔͂ōL
    WkPositionX := WkMonitorInfo.rcMonitor.Left;
    WkPositionY := WkMonitorInfo.rcMonitor.Top;
  end;

  // E̕擾
  case FTargetForm.BorderStyle of
    bsNone:
    begin
      // EBhE̋E
      WkBoundaryX := 0;
      WkBoundaryY := 0;
    end;
    bsDialog, bsSingle, bsToolWindow:
    begin
      // ̌ʕt̃EBhE̋E̕ +
      // ̌ʂ̂ȂEBhE̋E̕ 擾
      WkBoundaryX := GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXBORDER);
      WkBoundaryY := GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CYBORDER);
    end;
  else
    //bsSizeable, bsSizeToolWin
    // TCYύX\ȃEBhE̎͂͂ޘg̕ 擾
    WkBoundaryX := GetSystemMetrics(SM_CXFRAME);
    WkBoundaryY := GetSystemMetrics(SM_CYFRAME);
  end;

  // tH[̃TCYmsg.MinMaxInfo.ptMaxSizeɎw
  // E̕tH[̃TCYɔf
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    // bsSizeable, bsSingle 
    // ő剻̓j^Lʂ͈̔͂ōL
    msg.MinMaxInfo.ptMaxSize.X :=
      WkMonitorInfo.rcWork.Right - WkMonitorInfo.rcWork.Left +
      (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      WkMonitorInfo.rcWork.Bottom - WkMonitorInfo.rcWork.Top +
      (WkBoundaryY * 2);
  end
  else begin
    // bsDialog, bsNone, bsSizeToolWin, bsToolWindow 
    // ő剻̓j^Ŝ͈̔͂ōL
    msg.MinMaxInfo.ptMaxSize.X :=
      WkMonitorInfo.rcMonitor.Right - WkMonitorInfo.rcMonitor.Left +
      (WkBoundaryX * 2);
    msg.MinMaxInfo.ptMaxSize.Y :=
      WkMonitorInfo.rcMonitor.Bottom - WkMonitorInfo.rcMonitor.Top +
      (WkBoundaryY * 2);

    // Windows Vista(SP1)ł́A
    // bsSizeToolWin, bsToolWindow̎ɁAc̃TCY\
    // ۂN
    // Windows Vista(/SP2)͖mFAWindowsł͂̌ۂ͋NȂ
  end;

  // tH[̈ʒumsg.MinMaxInfo.ptMaxPositionɎw
  // E̕tH[̈ʒuɔf
  // msg.MinMaxInfo.ptMaxPosition
  // BorderStylebsSizeablebsSinglȅꍇ
  // ej^̗Lʂ̍_(0,0)ƂWw肷B
  // ȊOBorderStyleł
  // ej^̍_(0,0)ƂčWlԂ
  if (TargetForm.BorderStyle = bsSizeable) or
    (TargetForm.BorderStyle = bsSingle) then
  begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcWork.Left - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcWork.Top - WkBoundaryY;
  end
  else begin
    msg.MinMaxInfo.ptMaxPosition.X :=
      WkPositionX - WkMonitorInfo.rcMonitor.Left - WkBoundaryX;
    msg.MinMaxInfo.ptMaxPosition.Y :=
      WkPositionY - WkMonitorInfo.rcMonitor.Top - WkBoundaryY;
  end;

  {
  // fobOp
  ShowMessage(
    'msg.MinMaxInfo.ptMaxPosition.X:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxPosition.Y:' + IntToStr(msg.MinMaxInfo.ptMaxPosition.Y) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.X:' + IntToStr(msg.MinMaxInfo.ptMaxSize.X) + #13#10 +
    'msg.MinMaxInfo.ptMaxSize.Y:' + IntToStr(msg.MinMaxInfo.ptMaxSize.Y)
    );
  }
end;

{ TMonitorInfoParam }

constructor TMonitorInfoParam.Create(AOwner: TComponent);
begin
  inherited;
  if AOwner is TForm then
  begin
    FTargetForm := TForm(AOwner)
  end
  else begin
    FTargetForm := nil;
  end;
end;

function TMonitorInfoParam.DisplayMonitorInfo: TMonitorInfo;
begin
  // EChE݂Ȃꍇ͗O𔭐
  if FTargetForm = nil then
  begin
    raise ETargetFormIsNotFound.Create('TargetFormw肳Ă܂');
  end;
  if IsWindow(FTargetForm.Handle) = False then
  begin
    raise ETargetFormIsNotFound.Create('TargetFormŎw肵tH[݂Ă܂');
  end;

  GetMonitorInfoParam;
  result := FDisplayMonitorInfo;
end;


procedure TMonitorInfoParam.GetMonitorInfoParam;
begin
  // fBXvCj^Ɋւ擾
  // vC}j^̍_ƂčWlԂ
  ZeroMemory(@FMonitorInfo, sizeof(FMonitorInfo));
  FMonitorInfo.cbSize := SizeOf(FMonitorInfo);
  if GetMonitorInfo(FTargetForm.Monitor.Handle, @FMonitorInfo) = False then
  begin
    // Ô߃gC(̂ȁEEEHj
    Sleep(100);
    if GetMonitorInfo(FTargetForm.Monitor.Handle, @FMonitorInfo) = False then
    begin
      raise Exception.Create('APIGetMonitorInfo֐ŃG[܂' + #13#10 +
        'vO~OG[łAJ҂ɂ₢킹');
    end;
  end;

  // fBXvCj^Ɋւ擾
  // ej^̍_ƂčWlԂ
  FDisplayMonitorInfo.cbSize := SizeOf(FDisplayMonitorInfo);
  FDisplayMonitorInfo.dwFlags := FMonitorInfo.dwFlags;
  FDisplayMonitorInfo.rcMonitor.Top := 0;
  FDisplayMonitorInfo.rcMonitor.Left := 0;
  FDisplayMonitorInfo.rcMonitor.Bottom :=
    FMonitorInfo.rcMonitor.Bottom - FMonitorInfo.rcMonitor.Top;
  FDisplayMonitorInfo.rcMonitor.Right :=
    FMonitorInfo.rcMonitor.Right - FMonitorInfo.rcMonitor.Left;
  FDisplayMonitorInfo.rcWork.Top :=
    FMonitorInfo.rcWork.Top - FMonitorInfo.rcMonitor.Top;
  FDisplayMonitorInfo.rcWork.Left :=
    FMonitorInfo.rcWork.Left - FMonitorInfo.rcMonitor.Left;
  FDisplayMonitorInfo.rcWork.Bottom :=
    FMonitorInfo.rcWork.Bottom - FMonitorInfo.rcMonitor.Top;
  FDisplayMonitorInfo.rcWork.Right :=
    FMonitorInfo.rcWork.Right - FMonitorInfo.rcMonitor.Left;
end;

function TMonitorInfoParam.MonitorCount: Integer;
begin
  result := Screen.MonitorCount;
end;

function TMonitorInfoParam.MonitorInfo: TMonitorInfo;
begin
  // EChE݂Ȃꍇ͗O𔭐
  if FTargetForm = nil then
  begin
    raise ETargetFormIsNotFound.Create('TargetFormw肳Ă܂');
  end;
  if IsWindow(FTargetForm.Handle) = False then
  begin
    raise ETargetFormIsNotFound.Create('TargetFormŎw肵tH[݂Ă܂');
  end;

  GetMonitorInfoParam;
  result := FMonitorInfo;
end;

function TMonitorInfoParam.MonitorNum: Integer;
begin
  result := FTargetForm.Monitor.MonitorNum;
end;

procedure TMonitorInfoParam.SetTargetForm(const Value: TForm);
begin
  FTargetForm := Value;
end;

end.
